(*******************************************************************)
(*  This is part of SymbolicKAT, it is distributed under the       *)
(*  terms of the GNU Lesser General Public License version 3       *)
(*           (see file LICENSE for more details)                   *)
(*                                                                 *)
(*  Copyright 2014: Damien Pous. (CNRS, LIP - ENS Lyon, UMR 5668)  *)
(*******************************************************************)

(** Symbolic determinisation *)

open Common
open Bdd
open Automata

(** simple determinisation, using the powerset construction *)
val naive_dfa: ('s, formula) snfa -> ('s set, formula) sdfa


(** more efficient determinisation, where the underlying NFA is reindexed and memoised *)
val reindexed_dfa: ('s, formula) snfa -> (int_set, formula) sdfa * ('s set -> int_set)
