(*******************************************************************)
(*  This is part of SymbolicKAT, it is distributed under the       *)
(*  terms of the GNU Lesser General Public License version 3       *)
(*           (see file LICENSE for more details)                   *)
(*                                                                 *)
(*  Copyright 2014: Damien Pous. (CNRS, LIP - ENS Lyon, UMR 5668)  *)
(*******************************************************************)

(** High-level interface of the library, main entry point for standalone program *)

open Common
open Kat

(** do we use Hopcroft and Karp's version? *)
val hk: bool ref

(** do we put expressions in strict star form first? *)
val ssf: bool ref

(** which construction do we use *)
val construction: [ `Antimirov | `Brzozowski | `IlieYu ] ref

(** equivalence check, using the above parameters *)
val equiv : expr -> expr -> gstring option

(** utiliy for verifications: 
    check two expressions for equivalence ([`E]), difference ([`D]),
    left-to-right inclusion ([`L]), or right-to-left inclusion ([`R]) *)
val check : [ `D | `E | `L | `R ] -> string -> string -> unit
