(*******************************************************************)
(*  This is part of SymbolicKAT, it is distributed under the       *)
(*  terms of the GNU Lesser General Public License version 3       *)
(*           (see file LICENSE for more details)                   *)
(*                                                                 *)
(*  Copyright 2014: Damien Pous. (CNRS, LIP - ENS Lyon, UMR 5668)  *)
(*******************************************************************)

(** Up-to techniques *)

(** generic signature for up-to techniques *)
module type T = sig
  (** the type of bisimulation candidates *)
  type 'a t		
  (** the empty candidate *)
  val empty: unit -> 'a t		

  (** adding a pair to the candidate, returns [true] if it was not
      necessary (i.e., if already present, up to the considered technique) *)
  val merge: 'a t -> 'a -> 'a -> bool
end

(** plain relations: for the simple algorithm, without up to techniques *)
module SET: T


(** disjoint-set forests: for up to equivalence (HK without integration of DSF and BDDs) *)
module DSF: T
